import { useCallback, useEffect, useRef } from "react";

export default function useInfiniteScroll(
  currentPage,
  setCurrentPage,
  hasMore = false,
  callBackAPI,
  isLoading = false
) {
  const observer = useRef();

  const lastElementRef = useCallback(
    (node) => {
      console.log(observer, "-->observer", node, "-->node" , isLoading , "-->isLoading" );
      if (isLoading) return;
      if (observer?.current) observer?.current?.disconnect();
      observer.current = new IntersectionObserver((entries) => {
        console.log(entries, "-->entries");
        if (entries?.[0]?.isIntersecting && hasMore) {
          setCurrentPage((prevPageNumber) => prevPageNumber + 1);
        }
      });
      if (node) observer?.current?.observe(node);
    },
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [isLoading , hasMore]
  );

  useEffect(() => {
    console.log(currentPage, "-->currentPage");
    callBackAPI && callBackAPI(currentPage);
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [currentPage]);

  return { lastElementRef };
}
